/[gentoo-x86]/eclass/webapp.eclass
Gentoo

Diff of /eclass/webapp.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.21 Revision 1.55
1# Copyright 1999-2004 Gentoo Technologies, Inc. 1# Copyright 1999-2006 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/webapp.eclass,v 1.21 2004/05/25 10:22:02 stuart Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/webapp.eclass,v 1.55 2008/02/22 14:33:35 hollow Exp $
4# 4#
5# eclass/webapp.eclass 5# @ECLASS: webapp.eclass
6# @MAINTAINER:
7# web-apps@gentoo.org
6# Eclass for installing applications to run under a web server 8# @BLURB: functions for installing applications to run under a web server
7# 9# @DESCRIPTION:
10# The webapp eclass contains functions to handle web applications with
8# Part of the implementation of GLEP #11 11# webapp-config. Part of the implementation of GLEP #11
9#
10# Author(s) Stuart Herbert <stuart@gentoo.org>
11#
12# ------------------------------------------------------------------------
13#
14# The master copy of this eclass is held in Stu's subversion repository.
15#
16# If you make changes to this file and don't tell Stu, chances are that
17# your changes will be overwritten the next time Stu releases a new version
18# of webapp-config.
19#
20# ------------------------------------------------------------------------
21 12
22ECLASS=webapp
23INHERITED="$INHERITED $ECLASS"
24SLOT="${PVR}" 13SLOT="${PVR}"
25IUSE="$IUSE vhosts" 14IUSE="vhosts"
26DEPEND="$DEPEND >=net-www/webapp-config-1.7 app-portage/gentoolkit" 15DEPEND=">=app-admin/webapp-config-1.50.15"
16RDEPEND="${DEPEND}"
27 17
28EXPORT_FUNCTIONS pkg_postinst pkg_setup src_install pkg_prerm 18EXPORT_FUNCTIONS pkg_postinst pkg_setup src_install pkg_prerm
29 19
30INSTALL_DIR="/$PN" 20INSTALL_DIR="/${PN}"
31IS_UPGRADE=0 21IS_UPGRADE=0
32IS_REPLACE=0 22IS_REPLACE=0
33 23
34INSTALL_CHECK_FILE="installed_by_webapp_eclass" 24INSTALL_CHECK_FILE="installed_by_webapp_eclass"
35 25
36ETC_CONFIG="/etc/vhosts/webapp-config" 26ETC_CONFIG="${ROOT}etc/vhosts/webapp-config"
27WEBAPP_CONFIG="${ROOT}usr/sbin/webapp-config"
28WEBAPP_CLEANER="${ROOT}usr/sbin/webapp-cleaner"
37 29
38# ------------------------------------------------------------------------ 30# ==============================================================================
39# INTERNAL FUNCTION - USED BY THIS ECLASS ONLY 31# INTERNAL FUNCTIONS
40# 32# ==============================================================================
33
34# Load the config file /etc/vhosts/webapp-config
35# Supports both the old bash version, and the new python version
36webapp_read_config() {
37 debug-print-function $FUNCNAME $*
38
39 if has_version '>=app-admin/webapp-config-1.50'; then
40 ENVVAR=$(${WEBAPP_CONFIG} --query ${PN} ${PVR}) || die "Could not read settings from webapp-config!"
41 eval ${ENVVAR}
42 else
43 . ${ETC_CONFIG} || die "Unable to read ${ETC_CONFIG}"
44 fi
45}
46
41# Check whether a specified file exists within the image/ directory 47# Check whether a specified file exists in the given directory (`.' by default)
42# or not.
43#
44# @param $1 - file to look for
45# @param $2 - prefix directory to use
46# @return 0 on success, never returns on an error
47# ------------------------------------------------------------------------
48
49function webapp_checkfileexists () 48webapp_checkfileexists() {
50{ 49 debug-print-function $FUNCNAME $*
51 local my_prefix
52 50
53 [ -n "$2" ] && my_prefix="$2/" || my_prefix= 51 local my_prefix=${2:+${2}/}
54 52
55 if [ ! -e ${my_prefix}$1 ]; then 53 if [[ ! -e "${my_prefix}${1}" ]]; then
56 msg="ebuild fault: file $1 not found" 54 msg="ebuild fault: file '${1}' not found"
57 eerror "$msg" 55 eerror "$msg"
58 eerror "Please report this as a bug at http://bugs.gentoo.org/" 56 eerror "Please report this as a bug at http://bugs.gentoo.org/"
59 die "$msg" 57 die "$msg"
60 fi 58 fi
61} 59}
62 60
63# ------------------------------------------------------------------------
64# INTERNAL FUNCTION - USED BY THIS ECLASS ONLY
65# ------------------------------------------------------------------------
66
67function webapp_check_installedat 61webapp_check_installedat() {
68{ 62 debug-print-function $FUNCNAME $*
63 ${WEBAPP_CONFIG} --show-installed -h localhost -d "${INSTALL_DIR}" 2> /dev/null
64}
65
66webapp_strip_appdir() {
67 debug-print-function $FUNCNAME $*
68 echo "${1#${MY_APPDIR}/}"
69}
70
71webapp_strip_d() {
72 debug-print-function $FUNCNAME $*
73 echo "${1#${D}}"
74}
75
76webapp_strip_cwd() {
77 debug-print-function $FUNCNAME $*
78 echo "${1/#.\///}"
79}
80
81webapp_getinstalltype() {
82 debug-print-function $FUNCNAME $*
83 use vhosts && return
84
69 local my_output 85 local my_output
86 my_output="$(webapp_check_installedat)"
70 87
71 /usr/sbin/webapp-config --show-installed -h localhost -d $INSTALL_DIR 2> /dev/null 88 if [[ $? -eq 0 ]]; then
72} 89 # something is already installed there
90 # make sure it isn't the same version
73 91
74# ------------------------------------------------------------------------ 92 local my_pn="$(echo ${my_output} | awk '{ print $1 }')"
75# INTERNAL FUNCTION - USED BY THIS ECLASS ONLY 93 local my_pvr="$(echo ${my_output} | awk '{ print $2 }')"
76# ------------------------------------------------------------------------
77 94
78function webapp_import_config () 95 REMOVE_PKG="${my_pn}-${my_pvr}"
79{ 96
80 if [ -z "${MY_HTDOCSDIR}" ]; then 97 if [[ "${my_pn}" == "${PN}" ]]; then
81 . /etc/conf.d/webapp-config 98 if [[ "${my_pvr}" != "${PVR}" ]]; then
99 elog "This is an upgrade"
100 IS_UPGRADE=1
101 else
102 elog "This is a re-installation"
103 IS_REPLACE=1
104 fi
105 else
106 elog "${my_output} is installed there"
82 fi 107 fi
83 108 else
84 if [ -z "${MY_HTDOCSDIR}" ]; then 109 elog "This is an installation"
85 libsh_edie "/etc/conf.d/webapp-config not imported"
86 fi 110 fi
87} 111}
88 112
89# ------------------------------------------------------------------------ 113# ==============================================================================
90# INTERNAL FUNCTION - USED BY THIS ECLASS ONLY 114# PUBLIC FUNCTIONS
91# 115# ==============================================================================
92# ------------------------------------------------------------------------
93 116
94function webapp_strip_appdir () 117# @FUNCTION: webapp_configfile
95{ 118# @USAGE: <file> [more files ...]
96 local my_stripped="$1" 119# @DESCRIPTION:
97 echo "$1" | sed -e "s|${MY_APPDIR}/||g;" 120# Mark a file config-protected for a web-based application.
98}
99
100function webapp_strip_d ()
101{
102 echo "$1" | sed -e "s|${D}||g;"
103}
104
105function webapp_strip_cwd ()
106{
107 local my_stripped="$1"
108 echo "$1" | sed -e 's|/./|/|g;'
109}
110
111# ------------------------------------------------------------------------
112# EXPORTED FUNCTION - FOR USE IN EBUILDS
113#
114# Identify a config file for a web-based application.
115#
116# @param $1 - config file
117# ------------------------------------------------------------------------
118
119function webapp_configfile () 121webapp_configfile() {
120{ 122 debug-print-function $FUNCNAME $*
123
124 local m
125 for m in "$@"; do
121 webapp_checkfileexists "$1" "$D" 126 webapp_checkfileexists "${m}" "${D}"
122 echo $1
123 local MY_FILE="`webapp_strip_appdir $1`"
124 echo $MY_FILE
125 127
126 einfo "(config) $MY_FILE" 128 local my_file="$(webapp_strip_appdir "${m}")"
129 my_file="$(webapp_strip_cwd "${my_file}")"
130
131 elog "(config) ${my_file}"
127 echo "$MY_FILE" >> ${D}${WA_CONFIGLIST} 132 echo "${my_file}" >> ${D}/${WA_CONFIGLIST}
133 done
128} 134}
129 135
130# ------------------------------------------------------------------------ 136# @FUNCTION: webapp_hook_script
131# EXPORTED FUNCTION - FOR USE IN EBUILDS 137# @USAGE: <file>
132# 138# @DESCRIPTION:
133# Install a script that will run after a virtual copy is created, and 139# Install a script that will run after a virtual copy is created, and
134# before a virtual copy has been removed 140# before a virtual copy has been removed.
135#
136# @param $1 - the script to run
137# ------------------------------------------------------------------------
138
139function webapp_hook_script () 141webapp_hook_script() {
140{ 142 debug-print-function $FUNCNAME $*
143
141 webapp_checkfileexists "$2" 144 webapp_checkfileexists "${1}"
142 145
143 einfo "(hook) $1" 146 elog "(hook) ${1}"
144 cp "$1" "${D}${MY_HOOKSCRIPTSDIR}/`basename $1`" || die "Unable to install $1 into ${D}${MY_HOOKSCRIPTSDIR}/" 147 cp "${1}" "${D}/${MY_HOOKSCRIPTSDIR}/$(basename "${1}")" || die "Unable to install ${1} into ${D}/${MY_HOOKSCRIPTSDIR}/"
145 chmod 555 "${D}${MY_HOOKSCRIPTSDIR}/`basename $1`" 148 chmod 555 "${D}/${MY_HOOKSCRIPTSDIR}/$(basename "${1}")"
146} 149}
147 150
148# ------------------------------------------------------------------------ 151# @FUNCTION: webapp_postinst_txt
149# EXPORTED FUNCTION - FOR USE IN EBUILDS 152# @USAGE: <lang> <file>
150# 153# @DESCRIPTION:
151# Install a text file containing post-installation instructions. 154# Install a text file containing post-installation instructions.
152# 155webapp_postinst_txt() {
153# @param $1 - language code (use 'en' for now) 156 debug-print-function $FUNCNAME $*
154# @param $2 - the file to install
155# ------------------------------------------------------------------------
156 157
157function webapp_postinst_txt
158{
159 webapp_checkfileexists "$2" 158 webapp_checkfileexists "${2}"
160 159
161 einfo "(rtfm) $2 (lang: $1)" 160 elog "(info) ${2} (lang: ${1})"
162 cp "$2" "${D}${MY_APPDIR}/postinst-$1.txt" 161 cp "${2}" "${D}/${MY_APPDIR}/postinst-${1}.txt"
163} 162}
164 163
165# ------------------------------------------------------------------------ 164# @FUNCTION: webapp_postupgrade_txt
166# EXPORTED FUNCTION - FOR USE IN EBUILDS 165# @USAGE: <lang> <file>
167# 166# @DESCRIPTION:
168# Identify a script file (usually, but not always PHP or Perl) which is 167# Install a text file containing post-upgrade instructions.
169# 168webapp_postupgrade_txt() {
170# Files in this list may be modified to #! the required CGI engine when 169 debug-print-function $FUNCNAME $*
171# installed by webapp-config tool in the future.
172#
173# @param $1 - the cgi engine to use
174# @param $2 - the script file that could run under a cgi-bin
175#
176# ------------------------------------------------------------------------
177 170
178function webapp_runbycgibin ()
179{
180 webapp_checkfileexists "$2" "$D"
181 local MY_FILE="`webapp_strip_appdir $2`"
182 MY_FILE="`webapp_strip_cwd $MY_FILE`"
183
184 einfo "(cgi-bin) $1 - $MY_FILE"
185 echo "$1 $MY_FILE" >> ${D}${WA_RUNBYCGIBINLIST}
186}
187
188# ------------------------------------------------------------------------
189# EXPORTED FUNCTION - FOR USE IN EBUILDS
190#
191# Identify a file which must be owned by the webserver's user:group
192# settings.
193#
194# The ownership of the file is NOT set until the application is installed
195# using the webapp-config tool.
196#
197# @param $1 - file to be owned by the webserver user:group combo
198#
199# ------------------------------------------------------------------------
200
201function webapp_serverowned ()
202{
203 webapp_checkfileexists "$1" "$D"
204 local MY_FILE="`webapp_strip_appdir $1`"
205
206 einfo "(server owned) $MY_FILE"
207 echo "$MY_FILE" >> ${D}${WA_SOLIST}
208}
209
210# ------------------------------------------------------------------------
211# EXPORTED FUNCTION - FOR USE IN EBUILDS
212#
213# @param $1 - the webserver to install the config file for
214# (one of apache1, apache2, cherokee)
215# @param $2 - the config file to install
216# @param $3 - new name for the config file (default is `basename $2`)
217# this is an optional parameter
218#
219# NOTE:
220# this function will automagically prepend $1 to the front of your
221# config file's name
222# ------------------------------------------------------------------------
223
224function webapp_server_config ()
225{
226 webapp_checkfileexists "$2" 171 webapp_checkfileexists "${2}"
227 172
228 # sort out what the name will be of the config file 173 elog "(info) ${2} (lang: ${1})"
174 cp "${2}" "${D}/${MY_APPDIR}/postupgrade-${1}.txt"
175}
229 176
230 local my_file 177# helper for webapp_serverowned()
178_webapp_serverowned() {
179 debug-print-function $FUNCNAME $*
231 180
232 if [ -z "$3" ]; then 181 webapp_checkfileexists "${1}" "${D}"
233 $my_file="$1-`basename $2`" 182 local my_file="$(webapp_strip_appdir "${1}")"
234 else 183 my_file="$(webapp_strip_cwd "${my_file}")"
235 $my_file="$1-$3"
236 fi
237 184
238 # warning: 185 elog "(server owned) ${my_file}"
186 echo "${my_file}" >> "${D}/${WA_SOLIST}"
187}
188
189# @FUNCTION: webapp_serverowned
190# @USAGE: [-R] <file> [more files ...]
191# @DESCRIPTION:
192# Identify a file which must be owned by the webserver's user:group settings.
193# The ownership of the file is NOT set until the application is installed using
194# the webapp-config tool. If -R is given directories are handled recursively.
195webapp_serverowned() {
196 debug-print-function $FUNCNAME $*
197
198 local a m
199 if [[ "${1}" == "-R" ]]; then
200 shift
201 for m in "$@"; do
202 find "${D}${m}" | while read a; do
203 a=$(webapp_strip_d "${a}")
204 _webapp_serverowned "${a}"
205 done
206 done
207 else
208 for m in "$@"; do
209 _webapp_serverowned "${m}"
210 done
211 fi
212}
213
214# @FUNCTION: webapp_server_configfile
215# @USAGE: <server> <file> [new name]
216# @DESCRIPTION:
217# Install a configuration file for the webserver. You need to specify a
218# webapp-config supported <server>. if no new name is given `basename $2' is
219# used by default. Note: this function will automagically prepend $1 to the
220# front of your config file's name.
221webapp_server_configfile() {
222 debug-print-function $FUNCNAME $*
223
224 webapp_checkfileexists "${2}"
225
226 # WARNING:
239 # 227 #
240 # do NOT change the naming convention used here without changing all 228 # do NOT change the naming convention used here without changing all
241 # the other scripts that also rely upon these names 229 # the other scripts that also rely upon these names
242 230
231 local my_file="${1}-${3:-$(basename "${2}")}"
232
243 einfo "($1) config file '$my_file'" 233 elog "(${1}) config file '${my_file}'"
244 cp "$2" "${D}${MY_SERVERCONFIGDIR}/${my_file}" 234 cp "${2}" "${D}/${MY_SERVERCONFIGDIR}/${my_file}"
245} 235}
246 236
247# ------------------------------------------------------------------------ 237# @FUNCTION: webapp_sqlscript
248# EXPORTED FUNCTION - FOR USE IN EBUILDS 238# @USAGE: <db> <file> [version]
249# 239# @DESCRIPTION:
250# @param $1 - the db engine that the script is for 240# Install a SQL script that creates/upgrades a database schema for the web
251# (one of: mysql|postgres) 241# application. Currently supported database engines are mysql and postgres.
252# @param $2 - the sql script to be installed 242# If a version is given the script should upgrade the database schema from
253# @param $3 - the older version of the app that this db script 243# the given version to $PVR.
254# will upgrade from
255# (do not pass this option if your SQL script only creates
256# a new db from scratch)
257# ------------------------------------------------------------------------
258
259function webapp_sqlscript () 244webapp_sqlscript() {
260{ 245 debug-print-function $FUNCNAME $*
246
261 webapp_checkfileexists "$2" 247 webapp_checkfileexists "${2}"
262 248
263 # create the directory where this script will go 249 dodir "${MY_SQLSCRIPTSDIR}/${1}"
264 #
265 # scripts for specific database engines go into their own subdirectory
266 # just to keep things readable on the filesystem
267 250
268 if [ ! -d "${D}${MY_SQLSCRIPTSDIR}/$1" ]; then 251 # WARNING:
269 mkdir -p "${D}${MY_SQLSCRIPTSDIR}/$1" || libsh_die "unable to create directory ${D}${MY_SQLSCRIPTSDIR}/$1"
270 fi
271
272 # warning:
273 # 252 #
274 # do NOT change the naming convention used here without changing all 253 # do NOT change the naming convention used here without changing all
275 # the other scripts that also rely upon these names 254 # the other scripts that also rely upon these names
276 255
277 # are we dealing with an 'upgrade'-type script?
278 if [ -n "$3" ]; then 256 if [[ -n "${3}" ]]; then
279 # yes we are
280 einfo "($1) upgrade script from ${PN}-${PVR} to $3" 257 elog "(${1}) upgrade script for ${PN}-${3} to ${PVR}"
281 cp $2 ${D}${MY_SQLSCRIPTSDIR}/$1/${3}_to_${PVR}.sql 258 cp "${2}" "${D}${MY_SQLSCRIPTSDIR}/${1}/${3}_to_${PVR}.sql"
259 chmod 600 "${D}${MY_SQLSCRIPTSDIR}/${1}/${3}_to_${PVR}.sql"
282 else 260 else
283 # no, we are not
284 einfo "($1) create script for ${PN}-${PVR}" 261 elog "(${1}) create script for ${PN}-${PVR}"
285 cp $2 ${D}${MY_SQLSCRIPTSDIR}/$1/${PVR}_create.sql 262 cp "${2}" "${D}/${MY_SQLSCRIPTSDIR}/${1}/${PVR}_create.sql"
263 chmod 600 "${D}/${MY_SQLSCRIPTSDIR}/${1}/${PVR}_create.sql"
286 fi 264 fi
287} 265}
288 266
289# ------------------------------------------------------------------------ 267# @FUNCTION: webapp_src_preinst
290# EXPORTED FUNCTION - call from inside your ebuild's src_install AFTER 268# @DESCRIPTION:
291# everything else has run 269# You need to call this function in src_install() BEFORE anything else has run.
270# For now we just create required webapp-config directories.
271webapp_src_preinst() {
272 debug-print-function $FUNCNAME $*
273
274 dodir "${MY_HTDOCSDIR}"
275 dodir "${MY_HOSTROOTDIR}"
276 dodir "${MY_CGIBINDIR}"
277 dodir "${MY_ICONSDIR}"
278 dodir "${MY_ERRORSDIR}"
279 dodir "${MY_SQLSCRIPTSDIR}"
280 dodir "${MY_HOOKSCRIPTSDIR}"
281 dodir "${MY_SERVERCONFIGDIR}"
282}
283
284# ==============================================================================
285# EXPORTED FUNCTIONS
286# ==============================================================================
287
288# @FUNCTION: webapp_src_install
289# @DESCRIPTION:
290# This is the default src_install(). For now, we just make sure that root owns
291# everything, and that there are no setuid files.
292# 292#
293# For now, we just make sure that root owns everything, and that there 293# You need to call this function AFTER everything else has run in your custom
294# are no setuid files. I'm sure this will change significantly before 294# src_install().
295# the final version!
296# ------------------------------------------------------------------------
297
298function webapp_src_install () 295webapp_src_install() {
299{ 296 debug-print-function $FUNCNAME $*
297
300 chown -R ${VHOST_DEFAULT_UID}:${VHOST_DEFAULT_GID} ${D}/ 298 chown -R "${VHOST_DEFAULT_UID}:${VHOST_DEFAULT_GID}" "${D}/"
301 chmod -R u-s ${D}/ 299 chmod -R u-s "${D}/"
302 chmod -R g-s ${D}/ 300 chmod -R g-s "${D}/"
303 301
304 keepdir ${MY_PERSISTDIR} 302 keepdir "${MY_PERSISTDIR}"
305 fowners root:root ${MY_PERSISTDIR} 303 fowners "root:0" "${MY_PERSISTDIR}"
306 fperms 755 ${MY_PERSISTDIR} 304 fperms 755 "${MY_PERSISTDIR}"
307 305
308 # to test whether or not the ebuild has correctly called this function 306 # to test whether or not the ebuild has correctly called this function
309 # we add an empty file to the filesystem 307 # we add an empty file to the filesystem
310 # 308 #
311 # we used to just set a variable in the shell script, but we can 309 # we used to just set a variable in the shell script, but we can
312 # no longer rely on Portage calling both webapp_src_install() and 310 # no longer rely on Portage calling both webapp_src_install() and
313 # webapp_pkg_postinst() within the same shell process 311 # webapp_pkg_postinst() within the same shell process
314 312
315 touch ${D}/${MY_APPDIR}/${INSTALL_CHECK_FILE} 313 touch "${D}/${MY_APPDIR}/${INSTALL_CHECK_FILE}"
316} 314}
317 315
318# ------------------------------------------------------------------------ 316# @FUNCTION: webapp_pkg_setup
319# EXPORTED FUNCTION - call from inside your ebuild's pkg_config AFTER 317# @DESCRIPTION:
320# everything else has run 318# The default pkg_setup() for this eclass. This will gather required variables
319# from webapp-config and check if there is an application installed to
320# `${ROOT}/var/www/localhost/htdocs/${PN}/' if USE=vhosts is not set.
321# 321#
322# If 'vhosts' USE flag is not set, auto-install this app 322# You need to call this function BEFORE anything else has run in your custom
323# pkg_setup().
324webapp_pkg_setup() {
325 debug-print-function $FUNCNAME $*
326
327 # special case - some ebuilds *do* need to overwride the SLOT
328 if [[ "${SLOT}+" != "${PVR}+" && "${WEBAPP_MANUAL_SLOT}" != "yes" ]]; then
329 die "Set WEBAPP_MANUAL_SLOT=\"yes\" if you need to SLOT manually"
330 fi
331
332 # pull in the shared configuration file
333 G_HOSTNAME="localhost"
334 webapp_read_config
335
336 local my_dir="${ROOT}${VHOST_ROOT}/${MY_HTDOCSBASE}/${PN}"
337
338 # if USE=vhosts is enabled OR no application is installed we're done here
339 use vhosts || [[ ! -d "${my_dir}" ]] && return
340
341 local my_output
342 my_output="$(webapp_check_installedat)"
343
344 if [[ $? -ne 0 ]]; then
345 # okay, whatever is there, it isn't webapp-config-compatible
346 echo
347 ewarn
348 ewarn "You already have something installed in ${my_dir}"
349 ewarn
350 ewarn "Whatever is in ${my_dir}, it's not"
351 ewarn "compatible with webapp-config."
352 ewarn
353 ewarn "This ebuild may be overwriting important files."
354 ewarn
355 echo
356 ebeep 10
357 elif [[ "$(echo ${my_output} | awk '{ print $1 }')" != "${PN}" ]]; then
358 echo
359 eerror "You already have ${my_output} installed in ${my_dir}"
360 eerror
361 eerror "I cannot upgrade a different application"
362 eerror
363 echo
364 die "Cannot upgrade contents of ${my_dir}"
365 fi
366}
367
368# @FUNCTION: webapp_pkg_postinst
369# @DESCRIPTION:
370# The default pkg_postinst() for this eclass. This installs the web application to
371# `${ROOT}/var/www/localhost/htdocs/${PN}/' if USE=vhosts is not set. Otherwise
372# display a short notice how to install this application with webapp-config.
323# 373#
324# ------------------------------------------------------------------------ 374# You need to call this function AFTER everything else has run in your custom
325 375# pkg_postinst().
326function webapp_pkg_setup ()
327{
328 # add sanity checks here
329
330 if [ "$SLOT+" != "${PVR}+" ]; then
331 die "ebuild sets SLOT, overrides webapp.eclass"
332 fi
333
334 # pull in the shared configuration file
335
336 G_HOSTNAME="localhost"
337 . ${ETC_CONFIG} || die "Unable to open /etc/vhosts/webapp-config file"
338
339 # are we installing a webapp-config solution over the top of a
340 # non-webapp-config solution?
341
342 if ! use vhosts ; then
343 local my_dir="$VHOST_ROOT/$MY_HTDOCSBASE/$PN"
344 local my_output
345
346 if [ -d "$my_dir" ] ; then
347 einfo "You already have something installed in $my_dir"
348 einfo "Are you trying to install over the top of something I cannot upgrade?"
349
350 my_output="`webapp_check_installedat`"
351
352 if [ "$?" != "0" ]; then
353
354 # okay, whatever is there, it isn't webapp-config-compatible
355 ewarn
356 ewarn "Whatever is in $my_dir, it's not"
357 ewarn "compatible with webapp-config."
358 ewarn
359 ewarn "This ebuild may be overwriting important files."
360 ewarn
361 elif [ "`echo $my_output | awk '{ print $1 }'`" != "$PN" ]; then
362 eerror "$my_dir contains $my_output"
363 eerror "I cannot upgrade that"
364 die "Cannot upgrade contents of $my_dir"
365 else
366 einfo
367 einfo "I can upgrade the contents of $my_dir"
368 einfo
369 fi
370 fi
371 fi
372}
373
374function webapp_someunusedfunction ()
375{
376 # are we emerging something that is already installed?
377
378 if [ -d "${D}${MY_APPROOT}/${MY_APPSUFFIX}" ]; then
379 # yes we are
380 ewarn "Removing existing copy of ${PN}-${PVR}"
381 rm -rf "${D}${MY_APPROOT}/${MY_APPSUFFIX}"
382 fi
383}
384
385function webapp_getinstalltype ()
386{
387 # or are we upgrading?
388
389 if ! use vhosts ; then
390 # we only run webapp-config if vhosts USE flag is not set
391
392 local my_output
393
394 my_output="`webapp_check_installedat`"
395
396 if [ "$?" = "0" ] ; then
397 # something is already installed there
398 #
399 # make sure it isn't the same version
400
401 local my_pn="`echo $my_output | awk '{ print $1 }'`"
402 local my_pvr="`echo $my_output | awk '{ print $2 }'`"
403
404 REMOVE_PKG="${my_pn}-${my_pvr}"
405
406 if [ "$my_pn" == "$PN" ]; then
407 if [ "$my_pvr" != "$PVR" ]; then
408 einfo "This is an upgrade"
409 IS_UPGRADE=1
410 else
411 einfo "This is a re-installation"
412 IS_REPLACE=1
413 fi
414 else
415 einfo "$my_ouptut is installed there"
416 fi
417 else
418 einfo "This is an installation"
419 fi
420 fi
421}
422
423function webapp_src_preinst ()
424{
425 # create the directories that we need
426
427 dodir ${MY_HTDOCSDIR}
428 dodir ${MY_HOSTROOTDIR}
429 dodir ${MY_CGIBINDIR}
430 dodir ${MY_ICONSDIR}
431 dodir ${MY_ERRORSDIR}
432 dodir ${MY_SQLSCRIPTSDIR}
433}
434
435function webapp_pkg_postinst () 376webapp_pkg_postinst() {
436{ 377 debug-print-function $FUNCNAME $*
437 . ${ETC_CONFIG} 378
379 webapp_read_config
438 380
439 # sanity checks, to catch bugs in the ebuild 381 # sanity checks, to catch bugs in the ebuild
440
441 if [ ! -f ${MY_APPDIR}/${INSTALL_CHECK_FILE} ]; then 382 if [[ ! -f "${ROOT}${MY_APPDIR}/${INSTALL_CHECK_FILE}" ]]; then
442 eerror 383 eerror
443 eerror "This ebuild did not call webapp_src_install() at the end" 384 eerror "This ebuild did not call webapp_src_install() at the end"
444 eerror "of the src_install() function" 385 eerror "of the src_install() function"
445 eerror 386 eerror
446 eerror "Please log a bug on http://bugs.gentoo.org" 387 eerror "Please log a bug on http://bugs.gentoo.org"
449 eerror "installation is incomplete" 390 eerror "installation is incomplete"
450 eerror 391 eerror
451 die "Ebuild did not call webapp_src_install() - report to http://bugs.gentoo.org" 392 die "Ebuild did not call webapp_src_install() - report to http://bugs.gentoo.org"
452 fi 393 fi
453 394
454 # if 'vhosts' is not set in your USE flags, we install a copy of
455 # this application in /var/www/localhost/htdocs/${PN}/ for you
456
457 if ! use vhosts ; then 395 if ! use vhosts; then
458 echo 396 echo
459 einfo "vhosts USE flag not set - auto-installing using webapp-config" 397 elog "vhosts USE flag not set - auto-installing using webapp-config"
460 398
399 G_HOSTNAME="localhost"
400 webapp_read_config
401
402 local my_mode=-I
461 webapp_getinstalltype 403 webapp_getinstalltype
462 404
463 G_HOSTNAME="localhost"
464 . /etc/vhosts/webapp-config
465
466 local my_mode=-I
467
468 if [ "$IS_REPLACE" = "1" ]; then 405 if [[ "${IS_REPLACE}" == "1" ]]; then
469 einfo "${PN}-${PVR} is already installed - replacing" 406 elog "${PN}-${PVR} is already installed - replacing"
470 /usr/sbin/webapp-config -C -d "$INSTALL_DIR" 407 my_mode=-I
471 elif [ "$IS_UPGRADE" = "1" ]; then 408 elif [[ "${IS_UPGRADE}" == "1" ]]; then
472 einfo "$REMOVE_PKG is already installed - upgrading" 409 elog "${REMOVE_PKG} is already installed - upgrading"
473 my_mode=-U 410 my_mode=-U
474 else 411 else
475 einfo "${PN}-${PVR} is not installed - using install mode" 412 elog "${PN}-${PVR} is not installed - using install mode"
476 fi 413 fi
477 414
478 my_cmd="/usr/sbin/webapp-config $my_mode -h localhost -u root -d $INSTALL_DIR ${PN} ${PVR}" 415 my_cmd="${WEBAPP_CONFIG} ${my_mode} -h localhost -u root -d ${INSTALL_DIR} ${PN} ${PVR}"
479 einfo "Running $my_cmd" 416 elog "Running ${my_cmd}"
480 $my_cmd 417 ${my_cmd}
481 418
482 # remove the old version 419 echo
483 # 420 local cleaner="${WEBAPP_CLEANER} -p -C ${PN}"
484 # why do we do this? well ... 421 einfo "Running ${cleaner}"
485 # 422 ${cleaner}
486 # normally, emerge -u installs a new version and then removes the
487 # old version. however, if the new version goes into a different
488 # slot to the old version, then the old version gets left behind
489 #
490 # if USE=-vhosts, then we want to remove the old version, because
491 # the user is relying on portage to do the magical thing for it
492
493 if [ "$IS_UPGRADE" = "1" ] ; then
494 einfo "Removing old version $REMOVE_PKG"
495
496 emerge -C $CATEGORY/$REMOVE_PKG
497 fi
498 else 423 else
499 # vhosts flag is on 424 elog
500 #
501 # let's tell the administrator what to do next
502
503 einfo
504 einfo "The 'vhosts' USE flag is switched ON" 425 elog "The 'vhosts' USE flag is switched ON"
505 einfo "This means that Portage will not automatically run webapp-config to" 426 elog "This means that Portage will not automatically run webapp-config to"
506 einfo "complete the installation." 427 elog "complete the installation."
507 einfo 428 elog
508 einfo "To install $PN-$PVR into a virtual host, run the following command:" 429 elog "To install ${PN}-${PVR} into a virtual host, run the following command:"
509 einfo 430 elog
510 einfo " webapp-config -I -h <host> -d $PN $PN $PVR" 431 elog " webapp-config -I -h <host> -d ${PN} ${PN} ${PVR}"
511 einfo 432 elog
512 einfo "For more details, see the webapp-config(8) man page" 433 elog "For more details, see the webapp-config(8) man page"
513 fi 434 fi
514
515 return 0
516} 435}
517 436
437# @FUNCTION: webapp_pkg_prerm
438# @DESCRIPTION:
439# This is the default pkg_prerm() for this eclass. If USE=vhosts is not set
440# remove all installed copies of this web application. Otherwise instruct the
441# user to manually remove those copies. See bug #136959.
518function webapp_pkg_prerm () 442webapp_pkg_prerm() {
519{ 443 debug-print-function $FUNCNAME $*
520 # remove any virtual installs that there are
521 444
522 local my_output 445 local my_output=
446 my_output="$(${WEBAPP_CONFIG} --list-installs ${PN} ${PVR})"
447 [[ $? -ne 0 ]] && return
448
523 local x 449 local x
450 if ! use vhosts; then
524 451
525 my_output="`webapp-config --list-installs $PN $PVR`"
526
527 if [ "$?" != "0" ]; then
528 return
529 fi
530
531 # the changes to IFS here are necessary to ensure that we can cope
532 # with directories that contain spaces in the file names
533
534 # OLD_IFS="$IFS"
535 # IFS=" "
536
537 for x in $my_output ; do 452 for x in ${my_output}; do
538 # IFS="$OLD_IFS"
539
540 [ -f $x/.webapp ] && . $x/.webapp || ewarn "Cannot find file $x/.webapp" 453 [[ -f ${x}/.webapp ]] && . ${x}/.webapp || ewarn "Cannot find file ${x}/.webapp"
541
542 if [ -z "WEB_HOSTNAME" -o -z "WEB_INSTALLDIR" ]; then 454 if [[ -n "${WEB_HOSTNAME}" && -n "${WEB_INSTALLDIR}" ]]; then
455 ${WEBAPP_CONFIG} -C -h ${WEB_HOSTNAME} -d ${WEB_INSTALLDIR}
456 fi
457 done
458 else
459
543 ewarn "Don't forget to use webapp-config to remove the copy of" 460 ewarn "Don't forget to use webapp-config to remove any copies of"
544 ewarn "${PN}-${PVR} installed in" 461 ewarn "${PN}-${PVR} installed in"
545 ewarn 462 ewarn
463
464 for x in ${my_output}; do
465 [[ -f ${x}/.webapp ]] && . ${x}/.webapp || ewarn "Cannot find file ${x}/.webapp"
546 ewarn " $x" 466 ewarn " ${x}"
547 ewarn
548 else
549 # we have enough information to remove the virtual copy ourself
550
551 webapp-config -C -h ${WEB_HOSTNAME} -d ${WEB_INSTALLDIR}
552
553 # if the removal fails - we carry on anyway!
554 fi
555 # IFS=" "
556 done 467 done
557 468 fi
558 # IFS="$OLD_IFS"
559} 469}

Legend:
Removed from v.1.21  
changed lines
  Added in v.1.55

  ViewVC Help
Powered by ViewVC 1.1.20